package de.fhdw.wtf.common.ast;

import de.fhdw.wtf.common.ast.visitor.DatabaseIDStateVisitor;
import de.fhdw.wtf.common.ast.visitor.DatabaseIDStateVisitorReturn;
import de.fhdw.wtf.common.ast.visitor.DatabaseIDStateVisitorReturnException;
import de.fhdw.wtf.common.exception.generation.NoTypeIdSetException;

/**
 * In this State, the Database-ID is not set.
 * 
 */
public class DatabaseIDNotSetState implements DatabaseIDState {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 1081176099785190988L;
	
	@Override
	public void accept(final DatabaseIDStateVisitor v) {
		v.handle(this);
		
	}
	
	@Override
	public <X> X accept(final DatabaseIDStateVisitorReturn<X> v) {
		return v.handle(this);
	}
	
	@Override
	public <X, Y extends Exception> X accept(final DatabaseIDStateVisitorReturnException<X, Y> v) throws Y {
		return v.handle(this);
	}
	
	@Override
	public long getId() throws NoTypeIdSetException {
		throw new NoTypeIdSetException();
	}
	
}
