package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.AttributeModifierFindable;
import de.fhdw.wtf.common.ast.AttributeModifierMutable;
import de.fhdw.wtf.common.ast.AttributeModifierPrior;
import de.fhdw.wtf.common.ast.AttributeModifierSymmetric;
import de.fhdw.wtf.common.ast.AttributeModifierTransient;

/**
 * Visitor for {@link de.fhdw.wtf.common.ast.AttributeModifier}.
 */
public interface AttributModifierVisitor {
	
	/**
	 * Handle-Method.
	 * 
	 * @param prior
	 *            {@link AttributeModifierPrior}
	 * @return Boolean
	 */
	boolean handle(AttributeModifierPrior prior);
	
	/**
	 * Handle-Method.
	 * 
	 * @param tranzient
	 *            {@link AttributeModifierTransient}
	 * @return Boolean
	 */
	boolean handle(AttributeModifierTransient tranzient);
	
	/**
	 * Handle-Method.
	 * 
	 * @param findable
	 *            {@link AttributeModifierFindable}
	 * @return Boolean
	 */
	boolean handle(AttributeModifierFindable findable);
	
	/**
	 * Handle-Method.
	 * 
	 * @param mutable
	 *            {@link AttributeModifierMutable}
	 * @return Boolean
	 */
	boolean handle(AttributeModifierMutable mutable);
	
	/**
	 * Handle-Method.
	 * 
	 * @param symmetric
	 *            {@link AttributeModifierSymmetric}
	 * @return Boolean
	 */
	boolean handle(AttributeModifierSymmetric symmetric);
	
}
