package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.AtomicType;
import de.fhdw.wtf.common.ast.type.CompositeType;
import de.fhdw.wtf.common.ast.type.TypeProxy;

/**
 * Visitor for {@link de.fhdw.wtf.common.ast.type.Type}.
 * 
 */
public interface TypeVisitor {
	
	/**
	 * Handle-Method.
	 * 
	 * @param atomicType
	 *            {@link AtomicType}
	 */
	void handle(AtomicType atomicType);
	
	/**
	 * Handle-Method.
	 * 
	 * @param compositeType
	 *            {@link CompositeType}
	 */
	void handle(CompositeType compositeType);
	
	/**
	 * Handle-Method.
	 * 
	 * @param typeProxy
	 *            {@link TypeProxy}
	 */
	void handle(TypeProxy typeProxy);
}
