package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * {@link AbstractParserException} is the abstract Exception of the Parser. All Exceptions of the Parser should extends
 * this Class.
 * 
 */
public abstract class AbstractParserException extends Exception {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -3718305666599238665L;
	
	/**
	 * Token.
	 */
	private final Token token;
	
	/**
	 * Constructor of {@link AbstractParserException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	protected AbstractParserException(final Token token, final String message) {
		super(message + token.toString());
		this.token = token;
	}
	
	/**
	 * Returns the token.
	 * 
	 * @return token
	 */
	public Token getToken() {
		return this.token;
	}
	
}
