package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoArrowException} will be thrown if an {@link de.fhdw.wtf.common.token.symbols.ArrowToken} is expected,
 * but an another Token was found.
 * 
 */
public final class NoArrowException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 8081327339008971029L;
	
	/**
	 * Constructor of {@link NoArrowException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private NoArrowException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoArrowException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoArrowException}-Object.
	 */
	public static NoArrowException create(final Token token) {
		return new NoArrowException(token,
				de.fhdw.wtf.common.constants.parser.ExceptionConstants.NO_ARROW_EXCEPTION_MESSAGE);
	}
	
}
