package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.constants.parser.ExceptionConstants;
import de.fhdw.wtf.common.token.Token;

/**
 * The {@link NoIdentifierException} will be thrown if a {@link de.fhdw.wtf.common.token.IdentifierToken} is expected,
 * but an another Token was found.
 * 
 */
public class NoIdentifierException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = 1260421259295183645L;
	
	/**
	 * Constructor of {@link NoIdentifierException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	protected NoIdentifierException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link NoIdentifierException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link NoIdentifierException}-Object.
	 */
	public static NoIdentifierException create(final Token token) {
		return new NoIdentifierException(token, ExceptionConstants.NO_IDENTIFIER_EXCEPTION_MESSAGE);
	}
	
}
