package de.fhdw.wtf.common.task.result.visitor;

import de.fhdw.wtf.common.task.result.ExceptionalTaskResult;
import de.fhdw.wtf.common.task.result.OKTaskResult;

/**
 * Visitor for {@link de.fhdw.wtf.common.task.result.TaskResult}.
 * 
 */
public interface TaskResultVisitor {
	
	/**
	 * Handle-Method.
	 * 
	 * @param okTaskResult
	 *            {@link OKTaskResult}
	 */
	void handleOkTaskResult(OKTaskResult okTaskResult);
	
	/**
	 * Handle-Method.
	 * 
	 * @param exceptionalTaskResult
	 *            {@link ExceptionalTaskResult}
	 */
	void handleExceptionalTaskResult(ExceptionalTaskResult exceptionalTaskResult);
}
