package de.fhdw.wtf.walker.tasks;

import de.fhdw.wtf.common.ast.Attribute;
import de.fhdw.wtf.common.ast.Constructor;
import de.fhdw.wtf.common.ast.ConstructorOrOperation;
import de.fhdw.wtf.common.ast.Group;
import de.fhdw.wtf.common.ast.Model;
import de.fhdw.wtf.common.ast.Operation;
import de.fhdw.wtf.common.ast.type.AtomicType;
import de.fhdw.wtf.common.ast.type.ClassType;
import de.fhdw.wtf.common.ast.type.CompositeType;
import de.fhdw.wtf.common.ast.type.ListType;
import de.fhdw.wtf.common.ast.type.MapType;
import de.fhdw.wtf.common.ast.type.ProductType;
import de.fhdw.wtf.common.ast.type.SumType;
import de.fhdw.wtf.common.ast.type.ThrownType;
import de.fhdw.wtf.common.ast.type.TypeProxy;
import de.fhdw.wtf.common.ast.visitor.CompositeTypeVisitor;
import de.fhdw.wtf.common.ast.visitor.ConstructorOrOperationExceptionVisitor;
import de.fhdw.wtf.common.ast.visitor.TypeVisitor;
import de.fhdw.wtf.common.exception.walker.TaskException;
import de.fhdw.wtf.common.task.TaskExecutor;
import de.fhdw.wtf.walker.walker.SimpleWalkerTask;

/**
 * this Class Checks, wheather ther is no List-Value with a '!' as return type
 */
public final class NoThrownListTypesCheck extends SimpleWalkerTask {
	
	public NoThrownListTypesCheck(final Model m, final TaskExecutor taskmanager) {
		super(m, taskmanager);
		// TODO Auto-generated constructor stub
		
	}
	
	@Override
	public void handleClass(final ClassType c) throws TaskException {
		// nothing to do here! :)
	}
	
	@Override
	public void handleGroup(final Group g) throws TaskException {
		// Nothing to do here!
	}
	
	@Override
	public void handleAttribute(final Attribute a, final ClassType owner) throws TaskException {
		// nothing to do here!
	}
	
	@Override
	public void handleConstructorOrOperation(final ConstructorOrOperation coo, final ClassType owner)
			throws TaskException {
		coo.accept(new ConstructorOrOperationExceptionVisitor<TaskException>() {
			
			@Override
			public void handleOperation(final Operation operation) throws TaskException {
				operation.accept(new ConstructorOrOperationExceptionVisitor<TaskException>() {
					
					@Override
					public void handleOperation(final Operation operation) throws TaskException {
						operation.getReturnType().accept(new TypeVisitor() {
							
							@Override
							public void handle(final TypeProxy typeProxy) {
								// TODO Auto-generated method stub
								
							}
							
							@Override
							public void handle(final CompositeType compositeType) {
								if (compositeType.isThrownType()) {
									compositeType.accept(new CompositeTypeVisitor() {
										
										@Override
										public void handle(final ThrownType thrownType) {
											// TODO Auto-generated method stub
											
										}
										
										@Override
										public void handle(final SumType sum) {
											// TODO Auto-generated method stub
											
										}
										
										@Override
										public void handle(final ProductType product) {
											if (product.isThrownType()) {
												// TODO!!!
												// throw(InvalidThrowException.create("invalid throw!"));
											}
											
										}
										
										@Override
										public void handle(final MapType map) {
											// TODO Auto-generated method stub
											
										}
										
										@Override
										public void handle(final ListType list) {
											// TODO Auto-generated method stub
											
										}
									});
								}
								
								else {
									// Nothing to do here
								}
								
							}
							
							@Override
							public void handle(final AtomicType atomicType) {
								// TODO Auto-generated method stub
								
							}
						});
						
					}
					
					@Override
					public void handleConstructor(final Constructor constructor) throws TaskException {
						// TODO Auto-generated method stub
						
					}
				});
				
			}
			
			@Override
			public void handleConstructor(final Constructor constructor) throws TaskException {
				// TODO Auto-generated method stub
				
			}
		});
	}
	
	@Override
	public void finalizeTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void beginTask() throws TaskException {
		// TODO Auto-generated method stub
		
	}
	
}
